//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <SI_EFM8LB1_Register_Enums.h>                  // SFR declarations
#include "InitDevice.h"
// $[Generated Includes]
// [Generated Includes]$
unsigned char k, INB;
unsigned short i;
xdata unsigned char INARRAY[1024];
// xdata uint8_t INARRAY[2048];
//-------------------------------
void outspi(unsigned char byte) {
//----------
  SPI0CN0_NSSMD0 = 0; //    NSSMD0=0;    //4-wire   SPI0CN0_NSSMD0
//----------
  SPI0DAT = byte;  //    SPI
  //while (!SPIF); //    
  while (!SPI0CN0_SPIF)
    ; //    

  //----------
  SPI0CN0_NSSMD0 = 1; //NSSMD0=1;      //4-wire
//----------
      // SPIF=0;        //    .
  SPI0CN0_SPIF = 0;
}
//-----------------
unsigned char inspi() {
  unsigned char byte;
//--------
  SPI0CN0_NSSMD0 = 0;  //  NSSMD0=0;      //4-wire
//---------
  SPI0DAT = 0x0f;  //    .
  // while (!SPIF); //    
  while (!SPI0CN0_SPIF)
    ;      // Step1.3: Wait for end of transfer

//----------
  SPI0CN0_NSSMD0 = 1;         //NSSMD0=1;      //4-wire
//----------
      //SPIF=0;        //    .
  SPI0CN0_SPIF = 0;
  byte = SPI0DAT;
  return (byte);
}
//----------------

//-----------------------------------------------------------------------------
// main() Routine
// ----------------------------------------------------------------------------
void main(void) {
  // Call hardware initialization routine
  enter_DefaultMode_from_RESET();
//#####################################################
  START:
  //----------------
  while (inspi() != 0x40)
    ;
  //---------------------------------------------
  for (k = 0; k < 4; k++) {
    for (i = 0; i < 1024; i++) {     // 
      INARRAY[i] = inspi();    //  
    }                     // INARRAY[i] 1024 
  }                             // 4 .
  //---------------------------------------------------
  //for (i=0;i<64;i++) {           //  
  //   INARRAY[1023-i]=INARRAY[i]; //  
  //    }                          //  64 .
  //-------------------------------------------------------
  //while (inspi() != 0x40);

  for (k = 0; k < 4; k++) {            // 

    //  for (i=0;i<1024;i++) {     // 
    //  outspi(INARRAY[i]);        //  
    //       }                     // INTARRAY[i].

    for (i = 1024; i != 0; i--) {   //  UB1
      outspi(INARRAY[i - 1]);  // INARRAY[i]
    }                      //  .
  }                             // 4 .
  //-------------------------------------------------------
  goto START;
  //----------------

//#######################################################

}  //  Main

// $[Generated Run-time code]
// [Generated Run-time code]$

